routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'NewsController@index')->name('home')->middleware('auth');

Route::resource('users','UsersController')->only('show')->middleware('auth');
Route::resource('news','NewsController')->middleware('auth');
Route::resource('news.comments', 'CommentsController')->except('index', 'show')->middleware('auth');
Route::post('rating/news/{news}', 'NewsController@rating')->name('rating')->middleware('auth');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/News.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\BelongsToMany;
use Illuminate\Database\Eloquent\Relations\HasMany;

class News extends Model
{
    protected $fillable = ['user_id', 'category_id', 'body', 'publication_date', 'quality', 'relevance', 'attitude'];

    /**
     * @return BelongsTo
     */
    public function user() {
        return $this->belongsTo(User::class);
    }

    /**
     * @return BelongsTo
     */
    public function category() {
        return $this->belongsTo(Category::class);
    }

    /**
     * @return HasMany
     */
    public function comments() {
        return $this->hasMany(Comment::class);
    }

    /**
     * @return BelongsToMany
     */
    public function tags()
    {
        return $this->belongsToMany(Tag::class,'news_tag', 'news_id', 'tag_id');
    }


}

app/Http/Controllers/NewsController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use App\Http\Requests\NewsRequest;
use App\News;
use App\Tag;
use Illuminate\Auth\Access\AuthorizationException;
use Illuminate\Contracts\View\Factory;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\View\View;

class NewsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return Factory|View
     */
    public function index(Request $request)
    {
        $news = News::orderBy('publication_date', 'desc')->paginate(10);

        if (!empty($request->input('category_id'))) {
            $category_id = $request->input('category_id');
            $news = News::where('category_id', $category_id)
                ->orderBy('publication_date', 'desc')
                ->paginate(10);
        }

        if (!empty($request->input('tag_id'))) {
            $tag_id = $request->input('tag_id');
            $news = News::whereHas('tags', function ($query) use ($tag_id) {
                     $query->where('tag_id', $tag_id);
                 })
                ->orderBy('publication_date', 'desc')
                ->paginate(10);
        }

        if (!empty($request->input('category_id')) && !empty($request->input('tag_id'))) {
            $category_id = $request->input('category_id');
            $tag_id = $request->input('tag_id');
            $news = News::where('category_id', $category_id)
                 ->whereHas('tags', function ($query) use ($tag_id) {
                     $query->where('tag_id', $tag_id);
                 })
                ->orderBy('publication_date', 'desc')
                ->paginate(10);
        }

        $categories = Category::all();
        $tags = Tag::all();

        return view('news.index', compact('news', 'categories', 'tags'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return Factory|View
     */
    public function create()
    {
        $categories = Category::all();
        $tags = Tag::all();
        return view('news.create', compact('categories', 'tags'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param NewsRequest $request
     * @return RedirectResponse
     */
    public function store(NewsRequest $request)
    {
        Auth::user();
        $news = new News();
        $data = $request->all();
        $news->user_id = $request->user()->id;
        $data['user_id'] = $news->user_id;
        $news->create($data);

        return redirect()->route('news.index')->with('message', 'News created! Please wait until published by admin!');
    }

    /**
     * Display the specified resource.
     *
     * @param int $id
     * @return Factory|View
     */
    public function show($id)
    {
        $news = News::findOrFail($id);
        $tags = $news->tags()->pluck('title')->toArray();
        $user = $news->user->id;
        return view('news.show', compact('news', 'tags', 'user'));
    }


    /**
     * @param $id
     * @return Factory|View
     */
    public function edit($id)
    {
        $news = News::findOrFail($id);
        return view('news.edit', compact('news'));
    }


    /**
     * Update the specified resource in storage.
     *
     * @param NewsRequest $request
     * @param int $id
     * @return RedirectResponse
     */
    public function update(NewsRequest $request, $id)
    {
        $news = News::findOrFail($id);
        $data = $request->all();
        $news->update($data);
        return redirect()->route('news.index')->with('message', 'News updated!');
    }


    /**
     * @param $id
     * @return RedirectResponse
     */
    public function destroy($id)
    {
        $news = News::findOrFail($id);
        $news->delete();
        return redirect()->route('news.index')->with('message', 'News deleted!');
    }

    /**
     * @param Request $request
     * @param $id
     * @return RedirectResponse
     */
    public function rating(Request $request, $id)
    {

        $news = News::findOrFail($id);
        if ($request->input('quality') == 1) {
            $news->quality += 1;
        } else {
            $news->quality += -1;
        }

        if ($request->input('relevance') == 1) {
            $news->relevance += 1;
        } else {
            $news->relevance += -1;
        }

        if ($request->input('attitude') == 1) {
            $news->attitude += 1;
        } else {
            $news->attitude += -1;
        }

        $news->save();
        return redirect()->back();
    }
}

resources/views/news/create.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            <h5 class="mr-4">Add news</h5>
            >>
            <a class="ml-4" href="{{route('news.index')}}">Main Page</a>
        </div>

        <form method="post" action="{{route('news.store')}}">
            @csrf
            <div class="form-row mt-4">
                    <label for="category"><b>Categories</b></label><span class="text-danger">*</span>
                    <select class="custom-select @error('category_id') is-invalid @enderror" name="category_id"
                            id="category">
                        @foreach($categories as $category)
                            <option hidden disabled selected value="">Please select a category</option>
                            <option value="{{$category->id}}">
                                {{$category->title}}
                            </option>
                        @endforeach
                    </select>
                    @error('category_id')
                    <p class="error">{{ $message }}</p>
                    @enderror
            </div>
            <div class="form-row mt-4">
                    <label for="tags"><b>Tags</b></label><span class="text-danger">*</span>
                    <div class="form-check form-check-inline ml-2 mb-0">
                        @foreach($tags as $tag)
                            <input class="form-check-input ml-3 mr-3" type="checkbox" name="tags[]"
                                   value="{{$tag->id}}">{{$tag->title}}
                        @endforeach
                    </div>
            </div>
            <div class="form-row mt-4">
                    <label for="body"><b>Text</b></label><span class="text-danger">*</span>
                    <textarea rows="10" class="form-control @error('body') is-invalid @enderror" id="body"
                              name="body"></textarea>
                    @error('body')
                    <p class="error">{{ $message }}</p>
                    @enderror
            </div>
            <button type="submit" class="btn btn-primary mt-4 mb-4 pr-4 pl-4">Add</button>
        </form>
    </div>
@endsection

resources/views/news/edit.blade.php
@extends('layouts.app')
@section('content')
    <div class="container mt-2">
        <div class="col-6">
            <h5>Edit:</h5>
            <form method="post" action="{{route('news.update', ['news' => $news])}}">
                @csrf
                @method('put')
                <div class="form-row mt-3">
                    <div class="form-group col-md-12">
                        <input class="form-control" type="date" id="publication_date"
                               name="publication_date" value="{{$news->publication_date}}">
                    </div>
                    <div class="form-group col-md-12">
                        <textarea rows="10" class="form-control @error('body') is-invalid @enderror"
                                  id="body"
                                  name="body">{{$news->body}}</textarea>
                        @error('body')
                        <p class="error">{{$message}}</p>
                        @enderror
                    </div>
                </div>
                <button type="submit" class="btn btn-primary active pl-4 pr-4 mr-3">Edit</button>
                <a href="{{route('news.index')}}">Back</a>
            </form>
        </div>
    </div>
@endsection

resources/views/news/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container w-75">
        @if (session('message'))
            <div class="alert alert-primary" role="alert">
                {{ session('message') }}
            </div>
        @endif

        <div class="row pt-2 pb-4">
            <a class="mr-5" href="{{route('news.create')}}">Add news</a>
        </div>

        <div>
            <form action="{{route('news.index')}}" method="get">
                <div class="row d-flex justify-content-end mb-4">
                    <div class="form-group ml-1 mb-1">
                        <select class="form-control" name="category_id" style="font-size: 12px">
                            <option value="">Filter by category</option>
                            @foreach($categories as $category)
                                <option value="{{$category->id}}">{{$category->title}}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="form-group ml-1 mb-1">
                        <select class="form-control" name="tag_id" style="font-size: 12px">
                            <option value="">Filter by tag</option>
                            @foreach($tags as $tag)
                                <option value="{{$tag->id}}">{{$tag->title}}</option>
                            @endforeach
                        </select>
                    </div>
                    <div class="form-group ml-1 mb-1">
                        <button class="btn btn-success" style="font-size: 12px" type="submit"><i class="fas fa-filter"></i></button>
                    </div>
                </div>
            </form>
        </div>

        @foreach($news as $one_news)
            @if(Auth::user()->is_admin == 1 || $one_news->publication_date !== null && $one_news->publication_date <= \Carbon\Carbon::now())
                <div class="card mt-2" style="width: 100%">
                    <div class="card-body pb-2">
                        <blockquote class="blockquote mb-0 pt-1 mt-2">
                            <p class="text-truncate mb-0" style="font-size: 14px;">
                                {{$one_news->body}}
                            </p>
                            <p class="d-flex justify-content-end">
                                <a href="{{route('news.show', ['news' => $one_news])}}"
                                   class="card-link mt-2" style="font-size: 12px; cursor:pointer;">Read more</a>
                            </p>
                        </blockquote>
                    </div>
                </div>
            @endif
        @endforeach
    </div>

    <div style="margin-top: 50px" class="col-md-13 offset-md-5">
        {{$news->links()}}
    </div>

@endsection

resources/views/news/show.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <p style="font-size: 14px; font-weight: bold">Author: <a
                        href="{{route('users.show', ['user' => $user])}}" style="font-weight: normal">
                        {{$news->user->name}}
                    </a>
                </p>
                <p style="font-size: 14px; font-weight: bold">Created: <span
                        style="font-weight: normal">{{$news->created_at->diffForHumans()}}</span></p>
                <p style="font-size: 14px; font-weight: bold">Published: <span
                        style="font-weight: normal">{{$news->publication_date}}</span></p>
                <p style="font-size: 14px; font-weight: bold">Category: <span
                        style="font-weight: normal">{{$news->category->title}}</span></p>
                <div class="row mt-4">
                    <div class="col-md-3">
                        <p style="color: indianred">Quality score: <span
                                style="font-weight: bold">{{$news->quality}}</span></p>
                    </div>
                    <div class="col-md-4">
                        <p style="color: forestgreen">Relevance score: <span
                                style="font-weight: bold">{{$news->relevance}}</span></p>
                    </div>
                    <div class="col-md-4">
                        <p style="color: #117a8b">Attitude score: <span
                                style="font-weight: bold">{{$news->attitude}}</span></p>
                    </div>
                </div>
                <p class="mb-2 mt-4" style="text-align: justify; font-size: 15px;">
                    {{$news->body}}
                </p>
                <form method="get" action="{{route('news.index')}}">
                    <p style="font-size: 14px; font-weight: bold" class="mt-4">
                        Tags:
                        @foreach($tags as $tag)
                            <a href="{{route('news.index')}}" class="card-link ml-2"
                               style="font-size: 14px;cursor:pointer;">{{$tag}}</a>
                        @endforeach
                    </p>
                </form>
            </div>
        </div>
        <form method="post" action="{{route('rating', ['news' => $news])}}">
            @csrf
            <div class="row mt-4">
                <div class="form-group ml-1 mb-1">
                    <select class="form-control" style="font-size: 12px" name="quality">
                        <option value="">Is this news good?</option>
                        <option value="1">Yes</option>
                        <option value="0">No</option>
                    </select>
                </div>
                <div class="form-group ml-4 mb-1">
                    <select class="form-control" name="relevance" style="font-size: 12px">
                        <option value="">Is this news relevant?</option>
                        <option value="1">Yes</option>
                        <option value="0">No</option>
                    </select>
                </div>
                <div class="form-group ml-4 mb-1">
                    <select class="form-control" name="attitude" style="font-size: 12px">
                        <option value="">Did you like this news?</option>
                        <option value="1">Yes</option>
                        <option value="0">No</option>
                    </select>
                </div>
                <div class="form-group ml-4 mb-1">
                    <button class="btn btn-warning" style="font-size: 12px" type="submit">Submit</button>
                </div>
            </div>
        </form>


        <div class="row d-flex justify-content-end mt-5">
            <div class="btn-group">
                @if(Auth::user()->is_admin)
                    <div>
                        <a href="{{route('news.edit', ['news' => $news])}}" type="button"
                           class="btn btn-success ml-3 pr-4 pl-4">Edit</a>
                    </div>
                    <form method="post" action="{{route('news.destroy', ['news' => $news])}}">
                        @method('DELETE')
                        @csrf
                        <button type="submit" class="btn btn-danger ml-3 pr-4 pl-4 mr-0">Delete
                        </button>
                    </form>
                @endif
            </div>
        </div>


        <div class="row mt-4">
            <div id="comments-block" class="col-7">
                @csrf
                @foreach($news->comments as $comment)
                    <div class="media" id="delete-comment-{{$comment->id}}">
                        <img class="d-flex rounded-circle mt-0 mr-3" style="width: 50px; height: 50px"
                             src="{{asset('/images/default_photo.jpeg')}}" alt="Image">
                        <div class="media-body">
                            <div class="mb-3">
                                @if($comment->user_id == Auth::user()->id || Auth::user()->is_admin)
                                    <input type="hidden" id="news-id" value="{{$news->id}}">
                                    <span data-comment-id="{{$comment->id}}" class="delete" aria-hidden="true"
                                          style="float: right; font-size: 20px; color:red; cursor:pointer;"
                                          value="{{$news->id}}">&times;</span>
                                @endif
                            </div>
                            <p class="pr-4">{{$comment->body}}</p>
                            <div class="comment">
                                <span>Commented: {{$comment->user->name}}, </span>
                                <span>{{$comment->created_at->diffForHumans()}}</span>
                            </div>
                            <div>
                                @if($comment->user_id == Auth::user()->id || Auth::user()->is_admin)
                                    <a href="{{route('news.comments.edit', ['news' => $news, 'comment' => $comment])}}"
                                       style="font-size: 12px">Edit</a>
                                @endif
                            </div>
                            <hr>
                        </div>
                    </div>
                @endforeach
            </div>
            <div class="col-md-4 ml-auto mt-3">
                <div class="comment-form">
                    <form id="add-comment">
                        @csrf
                        <input type="hidden" id="news_id" value="{{$news->id}}">
                        <div class="form-group">
                            <label for="body">Comment</label>
                            <textarea name="body" class="form-control" id="body" rows="3"
                                      @error('category_id') is-invalid @enderror></textarea>
                        </div>
                        @error('body')
                        <p class="error">{{ $message }}</p>
                        @enderror
                        <button id="add-comment-btn" type="submit" class="btn btn-primary btn-block">Add comment
                        </button>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection